;********************************************************************
;	hex.asm - a condensed version of the hex output library from
;	the August/September 1991 issue of Inside Assembler
;********************************************************************

.model small
.code

;--------------------------------------------------------------------
;	hexfmt$yn - format a nybble in hexadecimal into the buffer
;
;	INP:	AL - contains the nybble to format
;			DI - ptr to location to store the formatted character
;	OUT:	DI - incremented to next buffer location
;	USES:	AL
;
hexfmt$yn proc
	and 	al, 0fh 			; Discard the upper nybble
	add 	al, '0' 			; Shift range from 0..f to '0'..'?'
	cmp 	al, '9' 			; If in range of ':'..'?' shift the
	jng		@F					; range to 'A'..'F'
	add 	al, 'A'-':'
@@: mov 	[di], al
	inc 	di
	ret
hexfmt$yn endp

;--------------------------------------------------------------------
;	hexfmt$bn - format a byte in hexadecimal into the buffer
;
;	INP:	AL - contains the byte to format
;			DI - ptr to buffer to hold the formatted character
;	OUT:	DI - points to the next buffer location
;	USES:	AL
;
hexfmt$bn proc
	push	ax					; Save the lower nybble
	shr 	al, 1				; Move upper nybble to lower
	shr 	al, 1
	shr 	al, 1
	shr 	al, 1
	call	hexfmt$yn			; Format upper nybble into buffer
	pop 	ax					; Restore lower nybble
	call	hexfmt$yn			; Format lower nybble into buffer
	ret
hexfmt$bn endp

;--------------------------------------------------------------------
;	hexfmt$wn - format a word in hexadecimal into the buffer
;
;	INP:	AX - word to fomat into the buffer
;			DI - ptr to buffer to hold formatted word
;	OUT:	DI - points to next buffer location
;	USES:	AX
;
hexfmt$wn proc
	xchg	ah, al				; Swap upper byte with lower byte
	call	hexfmt$bn			; Format upper byte into buffer
	xchg	ah, al				;
	call	hexfmt$bn			; Format lower byte into buffer
	ret
hexfmt$wn endp

end
