;********************************************************************
;	HEXINTST.ASM - test the hexadecimal input functions
;
;	To assemble: ml hexintst.asm hexin.asm hex.asm
;********************************************************************

.model small
.stack							; Create default 1K stack

	extrn		hexin_y$n : proc, hexin_b$n : proc, hexin_w$n : proc
	extrn		hexin_d$n : proc, hexfmt$wn	: proc

;--------------------------------------------------------------------
;	DATA area
;
.data

inpBuff 	db	50, 0, 50 dup( ? )
outBuff 	db	10 dup( ? )
errormsg	db	'Error - couldn''t convert character to hex!$'
prompt		db	'Enter two hex words, separated by a space'
			db	0dh, 0ah,':$'

;--------------------------------------------------------------------
;	START - input two different hexadecimal numbers, add them and
;	print the result
;
.code
.startup

	mov dx, offset prompt		; Display the prompt
	mov ah, 09h
	int 21h
	mov dx, offset inpBuff		; Get a string from the user
	mov ah, 0ah
	int 21h
	mov	di, offset inpBuff+2	; Read the first hex word
	call hexin_w$n
	jc error_abort
	mov	bx, ax					; Store the first word in BX
	call hexin_w$n				; Read the second hex word
	jc error_abort
	add	ax, bx					; Add the two numbers together

	mov di, offset outBuff		; Put the result in the output buffer
	jnc @F
	mov byte ptr [di], '1'		; Insert leading 1 if carry from add
	inc di
@@:
	call hexfmt$wn				; Format the hex word into buffer
	mov byte ptr [di], '$'		; Terminate the string
	mov dx, offset outBuff		; Print the number in output buffer
	mov ah, 9
	int 21h

	mov ax, 4c00h				; Exit with ERRORLEVEL==0 (success)
	int 21h

error_abort:					; ERROR detected!
	mov dx, offset errormsg 	; Print error message
	mov ah, 9
	int 21h
	mov ax, 4c01h				; Exit with ERRORLEVEL==1 (failure)
	int 21h

end
